void setup() {
  smooth();  

  myTable = loadTable("merged.csv");
  numRows = myTable.getRowCount();

  lockheed =  new float[numRows];
  exxon =  new float[numRows];
  sandp =  new float[numRows];
  gs =  new float[numRows];
  gold =  new float[numRows];
  dates = new int[numRows];
  monthDates = new int[numRows];

  colorMode(HSB, 255, 100, 100);  // I'll be using radians for the hue



  for (int i = 1; i < numRows; i++) {
    String[] day = myTable.getString(i, 0).split("/");
    dates[i] = Integer.parseInt(day[2]);
    //dates are backwards so larger date is always larger int
    String date = (Integer.parseInt(day[0])) < 10 ? day[2] +"0" + day[0] : day[2] + day[0];
    monthDates[i] = Integer.parseInt( date);
    lockheed[i] = myTable.getFloat(i, 1);
    exxon[i] = myTable.getFloat(i, 2);
    sandp[i] = myTable.getFloat(i, 3);
    gs[i] = myTable.getFloat(i, 4);
    gold[i] = myTable.getFloat(i, 5);
  }

  for (int i = 1; i < numRows; i++) {
    if (lockheed[i] <0) {
      lockheed[i] = lockheed[i-1];
    }
    if (exxon[i] <0) exxon[i] = exxon[i-1];
    if (sandp[i] <0) sandp[i] = sandp[i-1];
    if (gs[i] <0) gs[i] = gs[i-1];
    if (gold[i] <0) gold[i] = gold[i-1];
  }


  for (int i = 1; i < numRows; i++) {
    lMin = min(lMin, lockheed[i]);
    eMin = min(eMin, exxon[i]);
    sMin = min(sMin, sandp[i]);
    gMin = min(gMin, gs[i]);
    auMin = min(auMin, gold[i]);

    lMax = max(lMax, lockheed[i]);
    eMax = max(eMax, exxon[i]);
    sMax = max(sMax, sandp[i]);
    gMax = max(gMax, gs[i]);
    auMax = max(auMax, gold[i]);
  }


  for (int i = 1; i < numRows; i++) {
    lockheed[i] -= lMin;
    exxon[i]  -= eMin;
    sandp[i]  -= sMin;
    gs[i]  -= gMin;
    gold[i]  -= auMin;
  }

  println("lmin = " +lMin);
  println("aumin = " + auMin);
  for (int i = 1; i < numRows; i++) {
    lockheed[i] /= (lMax - lMin);
    exxon[i] /=  (eMax - eMin);
    sandp[i] /= (sMax - sMin);
    gs[i] /= (gMax - gMin);
    gold[i] /= (auMax - auMin);
  }
  //
  //  for (int i = 1; i < numRows; i++) {
  //        lockheed[i] *= 300;
  //        exxon[i] *=  300;
  //        sandp[i] *= 300;
  //        gs[i] *= 300;
  //    gold[i] *=300;
  //  }
  setupGUI();

  for (int i = 1; i <dates.length; i++) {
//    if(dates[i]==3) println("parsing 03 and the month is " + monthDates[i]);
    if (dates[i] > dates[i-1]) {
//      println("adding date for" +i);
      newYear.add(i);
    }
    if(monthDates[i] != monthDates[i-1]){

      monthMap.put(monthDates[i], i);
      newMonth.add(i);
    }
  } 
  
//  println("january either starts at " + newYear.get(1) + " or a " + monthMap.get(201));
//  println("initial ny size: " + newYear.size());

  //  for(int i = 0; i < lockheed.length/3; i++){
  //                                println(sandp[i*3]);
  //
  //  }

  size(1200, 800, OPENGL);                      // setting up the size of window
  center = width/2;
  buffer = width/2;
  hint(DISABLE_DEPTH_TEST);
  cam= new PeasyCam( this, 0, 0, 0, 3000);      
  frameRate(30);
  cam.rotateX(PI/8);
  cam.rotateY(PI/32);
  g3 = (PGraphics3D)g;     

  cam.setMinimumDistance(100);        // how near the camera can get 0,0,0
  cam.setMaximumDistance(3000);       // how far the camera can travel'
  cam.setSuppressRollRotationMode();
}

